package sos.net;


import javax.mail.Authenticator;
import javax.mail.PasswordAuthentication;

/**
 * @author ap
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class SOSMailAuthenticator extends Authenticator {

  	/** Attribut: user: Benutzername */
  	private String user 						= new String("");
  
  	/** Attribut: password: Kennwort */
  	private String password 					= new String("");
  


 	public SOSMailAuthenticator() {}


 	public SOSMailAuthenticator(String user) {
 
 		this.user = user;
 	}

 	public SOSMailAuthenticator( String user, String password) {
 	
 		this.user 		= user;
 		this.password 	= password;
 	}


	public PasswordAuthentication getPasswordAuthentication() {
		
		return new PasswordAuthentication(this.user, this.password);
	}


	/**
	  * setzt den Benutzernamen
	  * @param user Benutzername
	  */
	public void setUser(String user) {
		this.user = user;
	}

	/**
	 * liefert den Benutzernamen 
	 */
	public String getUser() {
		return this.user;
	}


	/**
	  * setzt das Kennwort
	  * @param password Kennwort
	  */
	public void setPassword(String password) {
		this.password = password;
	}

	/**
	 * liefert das Kennwort 
	 */
	public String getPassword() {
		return this.password;
	}

}
